open VecOps

let pi = 4.0 *. atan 1.0

let pi2 = 2.0 *. pi

let clamp low high v = min high (max low v)

let scale low high v =
  float (v - low) /. float (high - low)

let ipolate3 v col1 col2 =
  let v = clamp 0.0 1.0 v in
  let s = Vector.v3 v in
  let s'rev = Vector.v3 (1.0 -. v) in
    Vector.int3 (s'rev *||. Vector.float3 col1 +||. s *||. Vector.float3 col2)

